package com.objis.demostruts2;

import javax.servlet.http.HttpServletRequest;

import org.apache.struts2.interceptor.ServletRequestAware;

/* 
 * Action Hello Objis .  Cette action s'attend  recevoir 
 * un nom entr  partir d'une jsp : Nom.jsp. 
 *  
 * La logique mtier de cette action : 
 * concatnation du nom avec un message d'accueil 'static'
 * puis rendre ce message personnalis disponible pour 
 * le composant Result  qui il le forwarde.  
 */

public class HelloObjis implements ServletRequestAware  {
	
	/* Texte d'accueil 'static'. Pas d'internationnalisation (I18N)
	 */
	private static final String GREETING = "Bonjour ";

	/*
	 * Par default, le framework Struts 2  invoke la methode execute() 
	 * de l'objet Action.  Plusieurs strategies existent pour invoquer d'autres methodes
	 * , mais c'est la mthode invoque par defaut.
	 *  
	 */
	
    public String execute()  {
    	
    	/* Construit message d'accueil personnalis.  
    	 * Fait en sorte que ce message personnalis puisse tre lu 
    	 * par la vue (Result).
    	 */ 
    	
    	setAccueilPersonalise( GREETING + getNom() );
    	
    	/* Ici pas d'echec possible, donc on dit que notre logique mtier a reussit.
    	 */
    	
    	return "SUCCESS";
    }


    /*
     * Action struts 2 = Javabean = proprirs + mthodes
     * Necessaire au mcanisme de transfer de donnes de Struts 2.
     * le 'nom' et le 'messageAcceuilPersonalis' seront disponible dans ValueStack
     */
    
    private String nom;
    
 
    public String getNom() {
        return nom;
    }

    public void setNom(String nom) {
        this.nom = nom;
    }
    
    private String accueilPersonalise;
    
    public String getAccueilPersonalise()
    {    	
    	return accueilPersonalise;
    }
    
    public void setAccueilPersonalise( String accueilPersonalise ){
    	
    	// Gnration d'une exception pour faire travailler l'interacepteur Exception 
    	/*try {
			throw new java.lang.Exception();
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}*/
    	
    	this.accueilPersonalise = accueilPersonalise;
    }

	@Override
	public void setServletRequest(HttpServletRequest request) {
		// TODO Auto-generated method stub
		System.out.println("Rcupration paramtre 'nom' de la requte : " + request.getParameter("nom"));
	}
}
